#include <IRremote.h>
#include "IRCodes.h"

int Power01Pin = 5;
int Power02Pin = 6;
int Power03Pin = 7;
int Power04Pin = 8;
int Power05Pin = 9;
int StatusPin = 10;
int TestPin = 2;
int InfraPin = 19;
int ProgPin = 11;
int Power01State = 0;
int Power02State = 0;
int Power03State = 0;
int Power04State = 0;
int Power05State = 0;
int PowerONState = 0;
int PowerOFFState = 0;
int TestState = 0;
int ProgState = 0;
int Reading = 0;

IRrecv irrecv(InfraPin);
decode_results Codigo;

void setup()
{
  Serial.begin(9600);
  Serial.flush();
  Serial.println("LAGA Systems");
  Serial.println("IRControl v0.160224");
  Serial.println("Iniciando");
  irrecv.enableIRIn();  
  pinMode(Power01Pin, OUTPUT);
  pinMode(Power02Pin, OUTPUT);
  pinMode(Power03Pin, OUTPUT);
  pinMode(Power04Pin, OUTPUT);
  pinMode(Power05Pin, OUTPUT);
  pinMode(StatusPin, OUTPUT);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(StatusPin, LOW);
  pinMode(TestPin, INPUT_PULLUP);
  pinMode(ProgPin, INPUT_PULLUP);
  pinMode(InfraPin, INPUT);
  //digitalWrite(StatusPin, HIGH);
  ProgState = digitalRead(ProgPin);
  if (ProgState == HIGH)
  {
    Serial.println("Modo Lectura");
    Test_Leds();
  }
  else
  {
    Serial.println("Modo Normal");
  }
}

void loop()
{
  if (irrecv.decode(&Codigo))
  {
    if (Reading == 0)
    {
      Reading = 1;
      digitalWrite(StatusPin, HIGH);
      ProgState = digitalRead(ProgPin);
      if (ProgState == HIGH)
      {
        Serial.print("Codigo: 0x");
        Serial.println(Codigo.value, HEX);
      }
      else
      {
        switch (Codigo.value)
        {
          case Power01: //Salida N:1
            if (Power01State == 0)
            {
              Serial.println("Salida N:1 [ON]");
              digitalWrite(Power01Pin, HIGH);
              Power01State = 1;
            }
            else
            {
              Serial.println("Salida N:1 [OFF]");
              digitalWrite(Power01Pin, LOW);
              Power01State = 0;
            }
          break;
          case Power02: //Salida N:2
            if (Power02State == 0)
            {
              Serial.println("Salida N:2 [ON]");
              digitalWrite(Power02Pin, HIGH);
              Power02State = 1;
            }
            else
            {
              Serial.println("Salida N:2 [OFF]");
              digitalWrite(Power02Pin, LOW);
              Power02State = 0;
            }
          break;
          case Power03: //Salida N:3
            if (Power03State == 0)
            {
              Serial.println("Salida N:3 [ON]");
              digitalWrite(Power03Pin, HIGH);
              Power03State = 1;
            }
            else
            {
              Serial.println("Salida N:3 [OFF]");
              digitalWrite(Power03Pin, LOW);
              Power03State = 0;
            }
          break;
          case Power04: //Salida N:4
            if (Power04State == 0)
            {
              Serial.println("Salida N:4 [ON]");
              digitalWrite(Power04Pin, HIGH);
              Power04State = 1;
            }
            else
            {
              Serial.println("Salida N:4 [OFF]");
              digitalWrite(Power04Pin, LOW);
              Power04State = 0;
            }
          break;
          case Power05: //Salida N:5
            if (Power05State == 0)
            {
              Serial.println("Salida N:5 [ON]");
              digitalWrite(Power05Pin, HIGH);
              Power05State = 1;
            }
            else
            {
              Serial.println("Salida N:5 [OFF]");
              digitalWrite(Power05Pin, LOW);
              Power05State = 0;
            }
          break;
          case PowerON: //Power All ON
            Serial.println("Todas las Salidas [ON]");
            digitalWrite(Power01Pin, HIGH);
            digitalWrite(Power02Pin, HIGH);
            digitalWrite(Power03Pin, HIGH);
            digitalWrite(Power04Pin, HIGH);
            digitalWrite(Power05Pin, HIGH);
            Power01State = 1;
            Power02State = 1;
            Power03State = 1;
            Power04State = 1;
            Power05State = 1;
          break;
          case PowerOFF: //Power All OFF
            Serial.println("Todas las Salidas [OFF]");
            digitalWrite(Power01Pin, LOW);
            digitalWrite(Power02Pin, LOW);
            digitalWrite(Power03Pin, LOW);
            digitalWrite(Power04Pin, LOW);
            digitalWrite(Power05Pin, LOW);
            Power01State = 0;
            Power02State = 0;
            Power03State = 0;
            Power04State = 0;
            Power05State = 0;
          break;
          case Effect01: //Effect01
            Serial.println("Efecto N:01");
            Effect_One();
            Restore_Leds();
          break;
          case Effect02: //Effect02
            Serial.println("Efecto N:02");
            Effect_Two();
            Restore_Leds();
          break;
          case Effect03: //Effect03
            Serial.println("Efecto N:03");
            Effect_Three();
            Restore_Leds();
          break;
        }
        Reading = 0;
      }
    }
    //delay(500);
    digitalWrite(StatusPin, LOW);
    irrecv.resume();
  }
  else
  {
    TestState = digitalRead(TestPin);
    if (TestState == HIGH)
    {
      Test_Leds();
      Restore_Leds();
    }
  }
}

void Restore_Leds()
{
  Serial.println("Resturando Leds");
  if (Power01State == 1)
  {
    digitalWrite(Power01Pin, HIGH);
  }
  else
  {
    digitalWrite(Power01Pin, LOW);
  }
  if (Power02State == 1)
  {
    digitalWrite(Power02Pin, HIGH);
  }
  else
  {
    digitalWrite(Power02Pin, LOW);
  }
  if (Power03State == 1)
  {
    digitalWrite(Power03Pin, HIGH);
  }
  else
  {
    digitalWrite(Power03Pin, LOW);
  }
  if (Power04State == 1)
  {
    digitalWrite(Power04Pin, HIGH);
  }
  else
  {
    digitalWrite(Power04Pin, LOW);
  }
  if (Power05State == 1)
  {
    digitalWrite(Power05Pin, HIGH);
  }
  else
  {
    digitalWrite(Power05Pin, LOW);
  }
}

void Test_Leds()
{
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  digitalWrite(StatusPin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(StatusPin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  digitalWrite(StatusPin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(StatusPin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  digitalWrite(StatusPin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(StatusPin, LOW);
}

void Effect_One()
{
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, LOW);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, LOW);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, LOW);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  delay(250);
}

void Effect_Two()
{
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power05Pin, LOW);
  digitalWrite(Power04Pin, HIGH);
  delay(250);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power03Pin, HIGH);
  delay(250);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power02Pin, HIGH);
  delay(250);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power01Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  delay(250);
}

void Effect_Three()
{
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
  delay(250);
  digitalWrite(Power01Pin, HIGH);
  digitalWrite(Power02Pin, HIGH);
  digitalWrite(Power03Pin, HIGH);
  digitalWrite(Power04Pin, HIGH);
  digitalWrite(Power05Pin, HIGH);
  delay(250);
  digitalWrite(Power01Pin, LOW);
  digitalWrite(Power02Pin, LOW);
  digitalWrite(Power03Pin, LOW);
  digitalWrite(Power04Pin, LOW);
  digitalWrite(Power05Pin, LOW);
}

